#include "EndingState.h"
#include "../Renderer.h"
#include <iostream>
#include <SDL_image.h>

int score = 0;

void EndingState::init() {
    SDL_ShowCursor(SDL_ENABLE);
    std::cout << "Ending state initialized\n";
    score = SDL_GetTicks() / 100;
}

void EndingState::handleEvents(SDL_Event& event) {
    if (event.type == SDL_KEYDOWN) {
        switch (event.key.keysym.sym) {
            case SDLK_ESCAPE:
                std::cout << "Exiting game\n";
                this->changeRoom("exit");
                break;
            default:
                break;
        }
    }
}

void EndingState::update() {

}

void EndingState::render(SDL_Renderer* renderer, double deltaTime) {
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, SDL_ALPHA_OPAQUE);
    SDL_RenderClear(renderer);

    TTF_Font *font = TTF_OpenFont("./res/font.ttf", 24);
    drawText(renderer, font, "GAME OVER",
             WINDOW_WIDTH / 2 - 100, WINDOW_HEIGHT / 2 - 50, {255, 0, 0, SDL_ALPHA_OPAQUE});

    drawText(renderer, font, "Score: " + std::to_string(score),
             WINDOW_WIDTH / 2 - 120, WINDOW_HEIGHT / 2, {255, 255, 255, SDL_ALPHA_OPAQUE});

    SDL_RenderPresent(renderer);
}
