#include "MainMenuState.h"
#include <iostream>
#include <SDL_image.h>

#include "../Renderer.h"

int mouseX = 0;
int mouseY = 0;

int randomR = 255;
int randomG = 255;
int randomB = 255;

int randomSkip = 0;

void MainMenuState::update() {
    // hide cursor
}

void MainMenuState::init() {
    std::cout << "Main menu state initialized\n";
    SDL_ShowCursor(SDL_DISABLE);
}

void MainMenuState::handleEvents(SDL_Event& event) {
    if (event.type == SDL_KEYDOWN) {
        switch (event.key.keysym.sym) {
        case SDLK_RETURN:
            std::cout << "Switching to game state\n";
            break;
        case SDLK_ESCAPE:
            std::cout << "Exiting game\n";
            this->changeRoom("exit");
            break;
        default:
            break;
        }
    }

    if (event.type == SDL_MOUSEBUTTONDOWN) {
        this->changeRoom("game");
    }

    if (event.type == SDL_MOUSEMOTION) {
        mouseX = event.motion.x;
        mouseY = event.motion.y;
    }
}

void MainMenuState::render(SDL_Renderer* renderer, double deltaTime) {
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, SDL_ALPHA_OPAQUE);
    SDL_RenderClear(renderer);

    SDL_Texture* title = IMG_LoadTexture(renderer, "./res/logo.png");

    drawTexture(renderer, title, WINDOW_WIDTH/2-115, 100, 230, 125);

    SDL_SetRenderDrawColor(renderer, 255, 255, 255, SDL_ALPHA_OPAQUE);
    drawCircle(renderer, mouseX, mouseY, 10);
    TTF_Font *font = TTF_OpenFont("./res/font.ttf", 24);

    while (randomSkip == 30) {
        randomR = rand() % 200 + 55;
        randomG = rand() % 200 + 55;
        randomB = rand() % 200 + 55;
        randomSkip = 0;
    }

    drawText(renderer, font, "Click to Start", WINDOW_WIDTH/2-160, 320, {randomR, randomG, randomB, SDL_ALPHA_OPAQUE});

    randomSkip++;

    SDL_RenderPresent(renderer);

    SDL_Delay(deltaTime < 16 ? 16 - deltaTime : 0);
}
